<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /Users/sdy/AVS/github/avs-device-sdk/CapabilityAgents/GadgetManager/src/GadgetProtocol.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.6.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_939faa8d92a35492e2fdcb095b861749.html">GadgetManager</a></li><li class="navelem"><a class="el" href="dir_0fb3e4ed103a68a53472c85afbe2d392.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">GadgetProtocol.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;GadgetManager/GadgetProtocol.h&quot;</code><br />
<code>#include &lt;arpa/inet.h&gt;</code><br />
<code>#include &lt;<a class="el" href="_logger_8h_source.html">AVSCommon/Utils/Logger/Logger.h</a>&gt;</code><br />
<code>#include &quot;GadgetManager/GadgetProtocolConstants.h&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for GadgetProtocol.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_gadget_protocol_8cpp__incl.png" border="0" usemap="#_2_users_2sdy_2_a_v_s_2github_2avs-device-sdk_2_capability_agents_2_gadget_manager_2src_2_gadget_protocol_8cpp" alt=""/></div>
<map name="_2_users_2sdy_2_a_v_s_2github_2avs-device-sdk_2_capability_agents_2_gadget_manager_2src_2_gadget_protocol_8cpp" id="_2_users_2sdy_2_a_v_s_2github_2avs-device-sdk_2_capability_agents_2_gadget_manager_2src_2_gadget_protocol_8cpp">
<area shape="rect" id="node4" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="494,105,670,144"/>
<area shape="rect" id="node10" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="393,192,607,231"/>
<area shape="rect" id="node15" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="729,279,905,317"/>
<area shape="rect" id="node16" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="960,192,1136,231"/>
<area shape="rect" id="node21" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="713,192,910,231"/>
<area shape="rect" id="node22" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="149,365,325,404"/>
<area shape="rect" id="node17" href="_log_entry_stream_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryStream.h" alt="" coords="980,279,1156,317"/>
<area shape="rect" id="node19" href="_log_entry_buffer_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryBuffer.h" alt="" coords="980,365,1156,404"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1capability_agents"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">alexaClientSDK::capabilityAgents</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html">alexaClientSDK::capabilityAgents::gadgetManager</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_gadget_protocol_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_registration_manager_8cpp.html#a73216df79c9ad2b23fd2eef0a8f10d1b">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a7565b6996444ed95de30aa741948eb26"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a7565b6996444ed95de30aa741948eb26">alexaClientSDK::capabilityAgents::gadgetManager::isSpecialCharacter</a> (uint8_t byte)</td></tr>
<tr class="separator:a7565b6996444ed95de30aa741948eb26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada73dca8b646e75f28d1e781ea41d3e5"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ada73dca8b646e75f28d1e781ea41d3e5">alexaClientSDK::capabilityAgents::gadgetManager::getChecksumSection</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:ada73dca8b646e75f28d1e781ea41d3e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa39c87e852b345c1d4c2a94d28470b5"><td class="memItemLeft" align="right" valign="top">static uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#afa39c87e852b345c1d4c2a94d28470b5">alexaClientSDK::capabilityAgents::gadgetManager::readChecksum</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:afa39c87e852b345c1d4c2a94d28470b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad86459621e78499b7967b1d07a1bca31"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ad86459621e78499b7967b1d07a1bca31">alexaClientSDK::capabilityAgents::gadgetManager::getPayloadSection</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:ad86459621e78499b7967b1d07a1bca31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66cb11a1998f9b2b3f5029f8a3657f35"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a66cb11a1998f9b2b3f5029f8a3657f35">alexaClientSDK::capabilityAgents::gadgetManager::append</a> (uint8_t byte, std::vector&lt; uint8_t &gt; *v)</td></tr>
<tr class="separator:a66cb11a1998f9b2b3f5029f8a3657f35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ded4da80b7ddb12eb0e1050b1224b3e"><td class="memItemLeft" align="right" valign="top">static uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a7ded4da80b7ddb12eb0e1050b1224b3e">alexaClientSDK::capabilityAgents::gadgetManager::getNextSequenceId</a> (uint8_t sequenceId)</td></tr>
<tr class="separator:a7ded4da80b7ddb12eb0e1050b1224b3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:ab85226a738f96d6cb13b16f78fa9e2c9"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_gadget_protocol_8cpp.html#ab85226a738f96d6cb13b16f78fa9e2c9">TAG</a> {&quot;GadgetProtocol&quot;}</td></tr>
<tr class="memdesc:ab85226a738f96d6cb13b16f78fa9e2c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ab85226a738f96d6cb13b16f78fa9e2c9">More...</a><br /></td></tr>
<tr class="separator:ab85226a738f96d6cb13b16f78fa9e2c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac579aa39c558bfd83ea02294039b180d"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ac579aa39c558bfd83ea02294039b180d">alexaClientSDK::capabilityAgents::gadgetManager::COMMAND_ID_INDEX</a> = 1</td></tr>
<tr class="memdesc:ac579aa39c558bfd83ea02294039b180d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Command ID value in a properly formed GadgetProtocol packet.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ac579aa39c558bfd83ea02294039b180d">More...</a><br /></td></tr>
<tr class="separator:ac579aa39c558bfd83ea02294039b180d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae703b1adc155200ebaf07248988520e9"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ae703b1adc155200ebaf07248988520e9">alexaClientSDK::capabilityAgents::gadgetManager::ERROR_ID_INDEX</a> = 2</td></tr>
<tr class="memdesc:ae703b1adc155200ebaf07248988520e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Error ID value in a properly formed GadgetProtocol packet.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ae703b1adc155200ebaf07248988520e9">More...</a><br /></td></tr>
<tr class="separator:ae703b1adc155200ebaf07248988520e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad917a1f3173195877547bb5fc60b846a"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ad917a1f3173195877547bb5fc60b846a">alexaClientSDK::capabilityAgents::gadgetManager::SEQUENCE_ID_INDEX</a> = 3</td></tr>
<tr class="memdesc:ad917a1f3173195877547bb5fc60b846a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Sequence ID value in a properly formed GadgetProtocol packet.  <a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ad917a1f3173195877547bb5fc60b846a">More...</a><br /></td></tr>
<tr class="separator:ad917a1f3173195877547bb5fc60b846a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_registration_manager_8cpp.html#a73216df79c9ad2b23fd2eef0a8f10d1b">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="ab85226a738f96d6cb13b16f78fa9e2c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab85226a738f96d6cb13b16f78fa9e2c9">&#9670;&nbsp;</a></span>TAG</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string TAG {&quot;GadgetProtocol&quot;}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.6.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
